unit Setup1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, BIL, DdeMan, FileCtrl;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    EditInstallFrom: TEdit;
    EditInstallTo: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    ButtonInstall: TButton;
    ButtonExit: TButton;
    LabelMessage: TLabel;
    DdeClientConv1: TDdeClientConv;
    procedure ButtonExitClick(Sender: TObject);
    procedure ButtonInstallClick(Sender: TObject);
    Function InstallFile( Sender: TObject; cFrom: string; cTo:string; cDir:string; iCopyType:integer ):boolean;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ButtonExitClick(Sender: TObject);
begin
     halt;
end;

procedure TForm1.ButtonInstallClick(Sender: TObject);
var
   iButton: integer;
   TListParams: TStringList;
   sIDAPIDirectory: string;
   sIDAPIConfig: string;
   sIDAPIBLD: string;
   sWinINI: string;
   sWindows: string;
   sSystem: string;
   sProgram: string;
begin

   {Reset failed flag}
   SetInstallFailed(False);

   { Setup InstallFrom & InstallTo Directories}
   SetInstallFromDir(EditInstallFrom.Text);
   SetInstallToDir(EditInstallTo.Text);

   { Create Program directory }
   LabelMessage.Caption := 'Creating Directorys' ;
   LabelMessage.Refresh;
   if not bCreateDirectory(sGetProgDir) then
      begin
      LabelMessage.Caption := sGetProgDir + ' directory could not be created' ;
      LabelMessage.Refresh;
      exit;
      end;

   { Get Windows INI File }
   sWinINI := sGetWinDir + '\WIN.INI';

   {-------------------- IDAPI directory -------------------}
   { Get/Set IDAPI Directory }
   sIDAPIDirectory := sReadProfile( sWinINI, 'IDAPI','DLLPATH','');
   if length( sIDAPIDirectory ) = 0 then
      begin
      bWriteProfile(  sWinINI, 'IDAPI','DLLPATH','C:\IDAPI' );
      sIDAPIDirectory := sReadProfile( sWinINI, 'IDAPI','DLLPATH','');
      end;

   { Create IDAPI directory }
   if not bCreateDirectory(sIDAPIDirectory) then
      begin
      LabelMessage.Caption := sIDAPIDirectory + ' directory could not be created' ;
      LabelMessage.Refresh;
      exit;
      end;

 {-------------------- IDAPI ConfigFile01 -------------------}
   { Get/Set IDAPI ConfigFile01 Variables }
   sIDAPIConfig := sReadProfile( sWinINI, 'IDAPI','CONFIGFILE01','');
   if length( sIDAPIConfig ) = 0 then
      begin
      bWriteProfile(  sWinINI, 'IDAPI','CONFIGFILE01',sIDAPIDirectory + '\IDAPI.CFG' );
      sIDAPIConfig := sReadProfile( sWinINI, 'IDAPI','CONFIGFILE01','');
      end;

 {-------------------- Borland Language Drivers -------------------}
   { Get/Set IDAPI LDPath Variables }
   sIDAPIBLD := sReadProfile( sWinINI,'Borland Language Drivers','LDPath' ,'');
   if length( sIDAPIBLD ) = 0 then
      begin
      bWriteProfile(  sWinINI, 'Borland Language Drivers','LDPath',sIDAPIDirectory + '\LANGDRV' );
      sIDAPIBLD := sReadProfile( sWinINI, 'Borland Language Drivers','LDPath','');
      end;

   { Create Borland Language Drivers directory }
   if not bCreateDirectory(sIDAPIBLD) then
      begin
      LabelMessage.Caption := sIDAPIBLD + ' directory could not be created' ;
      LabelMessage.Refresh;
      exit;
      end;

   { Install files }
   InstallFile( Sender, 'IDAPI.CF_', 'IDAPI.CFG', 'I', fiExistsIgnore );
   InstallFile( Sender, 'IDAPI01.DL_', 'IDAPI01.DLL', 'I', fiSameDateTimeIgnore );
   InstallFile( Sender, 'IDASCI01.DL_', 'IDASCI01.DLL', 'I', fiSameDateTimeIgnore );
   InstallFile( Sender, 'IDBAT01.DL_', 'IDBAT01.DLL', 'I', fiSameDateTimeIgnore );
   InstallFile( Sender, 'IDDBAS01.DL_', 'IDDBAS01.DLL', 'I', fiSameDateTimeIgnore );
   InstallFile( Sender, 'IDODBC01.DL_', 'IDODBC01.DLL', 'I', fiSameDateTimeIgnore );
   InstallFile( Sender, 'IDPDX01.DL_', 'IDPDX01.DLL', 'I', fiSameDateTimeIgnore );
   InstallFile( Sender, 'IDQRY01.DL_', 'IDQRY01.DLL', 'I', fiSameDateTimeIgnore );
   InstallFile( Sender, 'IDR10009.DL_', 'IDR10009.DLL', 'I', fiSameDateTimeIgnore );
   InstallFile( Sender, 'ILD01.DL_', 'ILD01.DLL', 'I', fiSameDateTimeIgnore );

   { If any of install files fail exit }
   if bInstallFailed then
      exit;

   { Get Next Disk }
   while not FileExists( sGetFromDir + '\BDECFG.EX_') do 
      begin
      { Ask User for next disk}
      iButton := Application.MessageBox('Insert Disk  #2', 'Install', mb_OKCancel +
         mb_DefButton1);
      if iButton = IDCANCEL then
         begin
         LabelMessage.Caption := 'Install canceled by user request' ;
         LabelMessage.Refresh;
         Exit;
         end;
      end;
 
   { Install more files }
   InstallFile( Sender, 'BDECFG.EX_', 'BDECFG.EXE', 'I', fiSameDateTimeIgnore );
   InstallFile( Sender, 'BDECFG.HL_', 'BDECFG.HLP', 'I', fiSameDateTimeIgnore );
   InstallFile( Sender, 'BILDEMO.EX_', 'BILDEMO.EXE', 'P', fiSameDateTimeIgnore );
   InstallFile( Sender, 'BILDEMO.DB_', 'BILDEMO.DB', 'P', fiExistsIgnore );
   InstallFile( Sender, 'DBERASEW.EX_', 'DBERASEW.EXE', 'P', fiSameDateTimeIgnore);
   InstallFile( Sender, 'DBSTARTW.EX_', 'DBSTARTW.EXE', 'P', fiSameDateTimeIgnore);
   InstallFile( Sender, 'DBLOGW.EX_',   'DBLOGW.EXE', 'P', fiSameDateTimeIgnore);
   InstallFile( Sender, 'DBUNLOAW.EX_', 'DBUNLOAW.EXE', 'P', fiSameDateTimeIgnore);
   InstallFile( Sender, 'DBVALIDW.EX_', 'DBVALIDW.EXE', 'P', fiSameDateTimeIgnore);
   InstallFile( Sender, 'DBWRITEW.EX_', 'DBWRITEW.EXE', 'P', fiSameDateTimeIgnore);
   InstallFile( Sender, 'WSQLODBC.DL_', 'WSQLODBC.DLL', 'S', fiSameDateTimeIgnore);
   InstallFile( Sender, 'CTL3DV2.DL_', 'CTL3DV2.DLL', 'S', fiSameDateTimeIgnore);
   InstallFile( Sender, 'DBLIBW.DL_', 'DBLIBW.DLL', 'S', fiSameDateTimeIgnore); 
   InstallFile( Sender, 'WSQLEN.DL_', 'WSQLEN.DLL', 'S', fiSameDateTimeIgnore);
   InstallFile( Sender, 'ODBC.DL_', 'ODBC.DLL', 'S', fiSameDateTimeIgnore);
   InstallFile( Sender, 'ODBCINST.DL_', 'ODBCINST.DLL', 'S', fiSameDateTimeIgnore);

   { Get Windows & System Directory }
   sSystem := sGetSysDir;
   sWindows := sGetWinDir;
   sProgram := sGetProgDir;

   { Make sure ODBC is installed in Control }   
   bWriteProfile( sWindows+'\CONTROL.INI', 'MMCPL','ODBC',sSystem+'\ODBCINST.DLL');

   { SetUP ODBC.INI }
   bWriteProfile( sWindows+'\ODBC.INI','ODBC Data Sources', 'BILDEMO', 'Watcom SQL');
   bWriteProfile( sWindows+'\ODBC.INI','BILDEMO','Driver', sSystem+'\WSQLODBC.DLL');
   bWriteProfile( sWindows+'\ODBC.INI','BILDEMO','UID', 'dba');
   bWriteProfile( sWindows+'\ODBC.INI','BILDEMO','PWD', 'sql');
   bWriteProfile( sWindows+'\ODBC.INI','BILDEMO','Description', 'Blaise Install ');
   bWriteProfile( sWindows+'\ODBC.INI','BILDEMO','Database', sProgram + '\BILDEMO.DB');
   bWriteProfile( sWindows+'\ODBC.INI','BILDEMO','Start', 'dbstartw %d');
   bWriteProfile( sWindows+'\ODBC.INI','BILDEMO','KeysInSQLStatistics', '1');
   bWriteProfile( sWindows+'\ODBC.INI','BILDEMO','PreventNotCapable', '1');
   bWriteProfile( sWindows+'\ODBC.INI','BILDEMO','LastUser', '');

   { SetUP ODBCINST.INI }
   bWriteProfile( sWindows+'\ODBCINST.INI','ODBC Drivers','Watcom SQL', 'Installed');
   bWriteProfile( sWindows+'\ODBCINST.INI','Watcom SQL','Driver', sSystem+'\wsqlodbc.dll');
   bWriteProfile( sWindows+'\ODBCINST.INI','Watcom SQL','Setup', sSystem+'\wsqlodbc.dll');

   { Create a driver for Watcom }
   LabelMessage.Caption := 'Modifying IDAPI Drivers                  ';
   LabelMessage.Refresh;
   TListParams:= TStringList.create;
   TListParams.Add( 'INIT' );
   TListParams.Add( 'VERSION=1.0' );
   TListParams.Add( 'TYPE=SERVER' );
   TListParams.Add( 'DLL=IDODBC01.DLL' );
   TListParams.Add( 'ODBC DRIVER=WATCOM SQL' );
   TListParams.Add( 'DRIVER FLAGS=' );
   TListParams.Add( 'DB OPEN' );
   TListParams.Add( 'USER NAME=' );
   TListParams.Add( 'ODBC DSN=BILDEMO' );
   TListParams.Add( 'OPEN MODE=READ/WRITE' );
   TListParams.Add( 'SCHEMA CACHE SIZE=8' );
   TListParams.Add( 'SQLQRYMODE=' );
   TListParams.Add( 'LANGDRIVER=' );
   TListParams.Add( 'SQLPASSTHRU MODE=' );
   bBDEAddDriver('ODBC_WATCOM',TListParams);
   TListParams.Clear;

   { Create a Alias for Watcom }
   TListParams:= TStringList.create;
   TListParams.Add( 'DB INFO');
   TListParams.Add( 'TYPE=ODBC_WATCOM' );
   TListParams.Add( 'PATH='+sProgram);
   TListParams.Add( 'DB OPEN' );
   TListParams.Add( 'USER NAME=' );
   TListParams.Add( 'ODBC DSN=BILDEMO' );
   TListParams.Add( 'OPEN MODE=READ/WRITE' );
   TListParams.Add( 'SCHEMA CACHE SIZE=8' );
   TListParams.Add( 'SQLQRYMODE=' );
   TListParams.Add( 'LANGDRIVER=' );
   TListParams.Add( 'SQLPASSTHRU MODE=' );
   bBDEAddAlias('BILDEMO',TListParams);
   TListParams.Clear;

   { Create a program group & Item }
   LabelMessage.Caption := 'Creating Program Group & Item ';
   LabelMessage.Refresh;
   bAdd2ProgMan(DDEClientConv1, 'Blaise Install ', 'Blaise Install ', sGetProgDir + '\BILDEMO.EXE' );

   { Display closing message }
   LabelMessage.Caption := 'Install Complete                  ';
   LabelMessage.Refresh;

   { exit }
   ButtonInstall.Visible := False;
   ActiveControl := ButtonExit;

end;
Function  Tform1.InstallFile( Sender: TObject; cFrom: string; cTo:string; cDir:string; iCopyType:integer ):boolean;
var
   bRet: boolean;
begin

   { If one of the previous file failed exit }
   if bInstallFailed then
      exit;

   { Display message }
   LabelMessage.Caption := 'Installing ' + cTo + '                ' ;
   LabelMessage.Refresh;

   { Install the file }
   bRet := bInstallFile( cFrom, cTo, iCopyType, cDir );
   InstallFile := bRet;

   { If install fails display message }
   if not bRet then
      begin
      LabelMessage.Caption := 'Error Installing ' + cTo + '                ' ;
      LabelMessage.Refresh;
      end;
end;


end.
 